﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace XmlDSigEx
{
    class ECDsaProvider:SignatureProvider
    {
        public override bool CanHandle(System.Xml.XmlElement signatureElement)
        {
            string algorithm = GetAlgorithm(signatureElement);
            return algorithm.StartsWith(ECDsaAlgorithm.URI_ECDSA_PREFIX);
        }

        public override ISignatureAlgorithm GetSignatureAlgorithm(System.Xml.XmlElement signatureElement)
        {
            return new ECDsaAlgorithm(signatureElement);
        }
    }
}
